﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace CSSI.Windows.UI
{
    public partial class frmComboBoxSample : Form
    {
        private XmlNode _entityData;
        private XmlNamespaceManager namespaceManager;


        /// <summary>
        /// 
        /// </summary>
        public frmComboBoxSample(XmlNode entityData)
        {
            InitializeComponent();

            this._entityData = entityData;
            namespaceManager = new XmlNamespaceManager(new XmlNodeReader(this._entityData).NameTable);
            namespaceManager.AddNamespace("abc", "http://www.test.com");
        }

        //  form load event
        private void frmComboBoxSample_Load(object sender, EventArgs e)
        {
            if (this.DesignMode)
                return;


            DataSet ds = new DataSet("TestList");
            DataTable dt = new DataTable("TestListA");
            dt.Columns.Add("ID");
            dt.Columns.Add("KEY");
            dt.Columns.Add("VALUE");

            dt.Rows.Add(new[] { "1", "1", "A" });
            dt.Rows.Add(new[] { "2", "2", "B" });
            dt.Rows.Add(new[] { "3", "3", "C" });

            this.cmbListA.ValueMember = "VALUE";
            this.cmbListA.DisplayMember = "KEY";
            this.cmbListA.DataSource = dt;


            //  
            XmlNode xKey = this._entityData.SelectSingleNode("abc:ROLEID", namespaceManager);
            xKey.InnerXml = "(none)";   //set default value, if no value selected for control.
            XmlNode xValue = this._entityData.SelectSingleNode("abc:ROLETEXT", namespaceManager);
            xValue.InnerXml = "(none)"; //set default value, if no value selected for control.
            this.bindXMLObject(xKey, xValue);

        }


        public void bindXMLObject(object xKey, object xValue)
        {
            //  
            this.cmbListB.DataBindings.Add("Value", xKey, "InnerXml");
            this.cmbListB.DataBindings.Add("Text", xValue, "InnerXml");
        }

        //  first combo control value change event
        private void cmbListA_ValueChanged(object sender, EventArgs e)
        {
            this.cmbListB.DataSource = null;
            this.cmbListB.DataBind();


            if (null != this.cmbListA.Value)
            {
                //  
                //  will do some operations...
            }

        }

        private void cmbListB_Validating(object sender, CancelEventArgs e)
        {

        }

        private void cmbListB_Validated(object sender, EventArgs e)
        {

        }

    }
}
